#include "cordic.h"

/*

 == Console ==

avr-gcc -mmcu=atmega8 -o cordic-demo.elf -Os cordic.c cordic-asm.S cordic-demo.c
avr-nm --size-sort -S cordic-demo.elf | grep -i  ' t '
   
 == Makefile == 

CC = avr-gcc -mmcu=atmega8
   
cordic-asm.o: cordic-asm.S cordic.inc
	(CC) -S $< -o $@

cordic.o: cordic.c cordic.h
	(CC) -c $< -o $@ -Os

*/

cos_sin_t cs;

void cordic_sincos (void)
{
    // cs.sin = sin (1.5) als signed 1.15 Q-Format
    // cs.cos = cos (1.5) als signed 1.15 Q-Format
    cs = cordic (CORDIC_SCALE_IN (1.5));    
}

int main()
{
    cordic_sincos();
    return 0;
}

