;; a = 16 Bit   signed
;; b = 8  Bit unsigned
;; c = 16 Bit   signed
;; zero = 0
;; c += a*b / 2**8
.macro MADD16_8 c a b zero
    fmulsu  \a+1, \b
    add     \c,   R0
    adc     \c+1, R1
    
    fmul    \a,   \b
    sbc     \c+1, \zero
    add     \c,   R1
    adc     \c+1, \zero
.endm

;; a = 16 Bit   signed
;; b = 8  Bit unsigned
;; c = 16 Bit   signed
;; zero = 0
;; c -= a*b / 2**8
.macro MSUB16_8 c a b zero
    fmulsu  \a+1, \b
    sub     \c,   R0
    sbc     \c+1, R1
    
    fmul    \a,   \b
    adc     \c+1, \zero
    sub     \c,   R1
    sbci    \c+1, 0
.endm

;; a = 16 Bit   signed
;; b = 8  Bit unsigned
;; c = 16 Bit   signed
;; zero = 0
;; c += a*b / 2**16
.macro MADD16_16 c a b zero
    fmulsu  \a+1, \b
    sbc     \c+1, \zero
    rol     R0
    adc     \c,   R1
    adc     \c+1, \zero
    
    fmul    \a,   \b
    adc     \c,   \zero
    adc     \c+1, \zero
.endm

;; a = 16 Bit   signed
;; b = 8  Bit unsigned
;; c = 16 Bit   signed
;; zero = 0
;; c -= a*b / 2**16
.macro MSUB16_16 c a b zero
    fmulsu  \a+1, \b
    adc     \c+1, \zero
    rol     R0
    sbc     \c,   R1
    sbci    \c+1, 0
    
    fmul    \a,   \b
    sbci    \c,   0
    sbci    \c+1, 0
.endm

.macro PHI_ADD
    ;; phi += atan (2^{-i})
    lpm         _tmp,   z+
    lpm         _tmp+1, z+
    add         _phi,   _tmp
    adc         _phi+1, _tmp+1
.endm

.macro PHI_SUB
    ;; phi -= atan (2^{-i})
    lpm         _tmp,   z+
    lpm         _tmp+1, z+
    sub         _phi,   _tmp
    sbc         _phi+1, _tmp+1
.endm
